package nemosofts.online.live.adapter.Home;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.nemosofts.view.RoundedImageView;
import androidx.recyclerview.widget.RecyclerView;

import com.squareup.picasso.Picasso;

import java.util.List;

import nemosofts.online.live.R;
import nemosofts.online.live.callback.Callback;
import nemosofts.online.live.item.ItemData;

public class AdapterHomeRecent extends RecyclerView.Adapter<AdapterHomeRecent.MyViewHolder> {

    Context context;
    List<ItemData> arrayList;
    private final RecyclerItemClickListener listener;

    public AdapterHomeRecent(Context context, List<ItemData> arrayList, RecyclerItemClickListener listener) {
        this.context = context;
        this.arrayList = arrayList;
        this.listener = listener;
    }

    static class MyViewHolder extends RecyclerView.ViewHolder {

        RelativeLayout rl_recent;
        private final TextView tv_recent_title;
        private final RoundedImageView iv_recently;

        MyViewHolder(View view) {
            super(view);
            tv_recent_title = view.findViewById(R.id.tv_recent_title);
            iv_recently = view.findViewById(R.id.iv_recently);
            rl_recent = view.findViewById(R.id.rl_recent);
        }
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View itemView = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_recently, parent, false);
        return new MyViewHolder(itemView);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {

        holder.tv_recent_title.setText(arrayList.get(position).getTitle());

        Picasso.get()
                .load(arrayList.get(position).getThumb())
                .resize(300,300)
                .placeholder(R.drawable.material_design_default)
                .into(holder.iv_recently);

        holder.rl_recent.setOnClickListener(v -> {
            try {
                if (Boolean.TRUE.equals(Callback.isPurchases)){
                    listener.onClick(holder.getAbsoluteAdapterPosition());
                } else {
                    if (Boolean.TRUE.equals(arrayList.get(position).getIsPremium()) && Boolean.TRUE.equals(!Callback.isPurchases)){
                        listener.onRewardAds(position);
                    } else {
                        listener.onClick(holder.getAbsoluteAdapterPosition());
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        });
    }

    @Override
    public long getItemId(int id) {
        return id;
    }

    @Override
    public int getItemCount() {
        return arrayList.size();
    }

    public interface RecyclerItemClickListener{
        void onClick(int position);
        void onRewardAds(int position);
    }

}